Index: /branches/LearningClassifierSystems/HeuristicLab.Algorithms.LearningClassifierSystems/3.3/HeuristicLab.Algorithms.LearningClassifierSystems-3.3.csproj
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Algorithms.LearningClassifierSystems/3.3/HeuristicLab.Algorithms.LearningClassifierSystems-3.3.csproj	(revision 9193)
+++ /branches/LearningClassifierSystems/HeuristicLab.Algorithms.LearningClassifierSystems/3.3/HeuristicLab.Algorithms.LearningClassifierSystems-3.3.csproj	(revision 9194)
@@ -50,8 +50,4 @@
     <Reference Include="HeuristicLab.Common-3.3">
       <HintPath>..\..\..\trunk\sources\bin\HeuristicLab.Common-3.3.dll</HintPath>
-      <Private>False</Private>
-    </Reference>
-    <Reference Include="HeuristicLab.Core-3.3">
-      <HintPath>..\..\..\trunk\sources\bin\HeuristicLab.Core-3.3.dll</HintPath>
       <Private>False</Private>
     </Reference>
@@ -116,4 +112,8 @@
   </ItemGroup>
   <ItemGroup>
+    <ProjectReference Include="..\..\HeuristicLab.Core\3.3\HeuristicLab.Core-3.3.csproj">
+      <Project>{C36BD924-A541-4A00-AFA8-41701378DDC5}</Project>
+      <Name>HeuristicLab.Core-3.3</Name>
+    </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.Encodings.CombinedIntegerVectorEncoding\3.3\HeuristicLab.Encodings.CombinedIntegerVectorEncoding-3.3.csproj">
       <Project>{CE7163C5-BFFE-45F0-9BD0-E10EF24E8BD2}</Project>
Index: /branches/LearningClassifierSystems/HeuristicLab.Algorithms.LearningClassifierSystems/3.3/LearningClassifierSystemMainLoop.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Algorithms.LearningClassifierSystems/3.3/LearningClassifierSystemMainLoop.cs	(revision 9193)
+++ /branches/LearningClassifierSystems/HeuristicLab.Algorithms.LearningClassifierSystems/3.3/LearningClassifierSystemMainLoop.cs	(revision 9194)
@@ -76,4 +76,5 @@
     private DoDeletionBeforeCoveringOperator doDeletionBeforeCovering;
     private CoveringOperator covering;
+    private CountNumberOfUniqueActions countNumberOfUniqueActions;
 
     private UniformSomePositionManipulator test;
@@ -136,5 +137,5 @@
       ConditionalSelector actionMatchSelector = new ConditionalSelector();
       SubScopesProcessor matchSetSubScopesProcessor = new SubScopesProcessor();
-      CountNumberOfUniqueActions countNumberOfUniqueActions = new CountNumberOfUniqueActions();
+      countNumberOfUniqueActions = new CountNumberOfUniqueActions();
       doDeletionBeforeCovering = new DoDeletionBeforeCoveringOperator();
       ConditionalBranch doDeletionBeforeCoveringConditionalBranch = new ConditionalBranch();
@@ -439,5 +440,5 @@
       classifierFetcher.OperatorParameter.ActualName = problem.ClassifierFetcherParameter.Name;
 
-      test.FetchedClassifierParameter.ActualName = problem.ClassifierFetcher.CurrentClassifierToMatchParameter.ActualName;
+      test.FetchedConditionParameter.ActualName = problem.ClassifierFetcher.CurrentInputToMatchParameter.ActualName;
       test.PossibleActionsParameter.ActualName = problem.PossibleActionsConcreteClassParameter.Name;
 
@@ -454,7 +455,8 @@
       actionSetSubsumption.OperatorParameter.ActualName = problem.ActionSetSubsumptionOperatorParameter.Name;
 
-      matchConditionOperator.TargetMatchParameter.ActualName = problem.ClassifierFetcher.CurrentClassifierToMatchParameter.ActualName;
+      matchConditionOperator.TargetMatchParameter.ActualName = problem.ClassifierFetcher.CurrentInputToMatchParameter.ActualName;
 
       doDeletionBeforeCovering.MinimalNumberOfUniqueActionsParameter.ActualName = problem.ThetaMinimalNumberOfActionsParameter.Name;
+      doDeletionBeforeCovering.ClassifierComparerParameter.ActualName = problem.ClassifierComparerParameter.Name;
 
       covering.SolutionCreatorParameter.ActualName = problem.CoveringSolutionCreatorParameter.Name;
@@ -465,4 +467,7 @@
       predictionArrayCalculator.PredictionParameter.ActualName = problem.Evaluator.PredictionParameter.ActualName;
       predictionArrayCalculator.FitnessParameter.ActualName = problem.Evaluator.FitnessParameter.ActualName;
+      predictionArrayCalculator.ClassifierComparerParameter.ActualName = problem.ClassifierComparerParameter.Name;
+
+      countNumberOfUniqueActions.ClassifierComparerParameter.ActualName = problem.ClassifierComparerParameter.Name;
     }
     //private void ParameterizeSelectors() {
Index: /branches/LearningClassifierSystems/HeuristicLab.Core/3.3/Collections/ItemDictionary.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Core/3.3/Collections/ItemDictionary.cs	(revision 9193)
+++ /branches/LearningClassifierSystems/HeuristicLab.Core/3.3/Collections/ItemDictionary.cs	(revision 9194)
@@ -59,5 +59,7 @@
     public ItemDictionary() : base() { }
     public ItemDictionary(int capacity) : base(capacity) { }
+    public ItemDictionary(IEqualityComparer<TKey> comparer) : base(comparer) { }
     public ItemDictionary(IDictionary<TKey, TValue> dictionary) : base(dictionary) { }
+    public ItemDictionary(IDictionary<TKey, TValue> dictionary, IEqualityComparer<TKey> comparer) : base(dictionary, comparer) { }
 
     public object Clone() {
Index: /branches/LearningClassifierSystems/HeuristicLab.Core/3.3/HeuristicLab.Core-3.3.csproj
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Core/3.3/HeuristicLab.Core-3.3.csproj	(revision 9193)
+++ /branches/LearningClassifierSystems/HeuristicLab.Core/3.3/HeuristicLab.Core-3.3.csproj	(revision 9194)
@@ -41,5 +41,5 @@
     <DebugType>full</DebugType>
     <Optimize>false</Optimize>
-    <OutputPath>$(SolutionDir)\bin\</OutputPath>
+    <OutputPath>..\..\..\..\trunk\sources\bin\</OutputPath>
     <DefineConstants>DEBUG;TRACE</DefineConstants>
     <ErrorReport>prompt</ErrorReport>
@@ -52,5 +52,5 @@
     <DebugType>pdbonly</DebugType>
     <Optimize>true</Optimize>
-    <OutputPath>$(SolutionDir)\bin\</OutputPath>
+    <OutputPath>..\..\..\..\trunk\sources\bin\</OutputPath>
     <DefineConstants>TRACE</DefineConstants>
     <ErrorReport>prompt</ErrorReport>
@@ -63,5 +63,5 @@
   <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Debug|x86' ">
     <DebugSymbols>true</DebugSymbols>
-    <OutputPath>$(SolutionDir)\bin\</OutputPath>
+    <OutputPath>..\..\..\..\trunk\sources\bin\</OutputPath>
     <DefineConstants>DEBUG;TRACE</DefineConstants>
     <DebugType>full</DebugType>
@@ -71,5 +71,5 @@
   </PropertyGroup>
   <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|x86' ">
-    <OutputPath>$(SolutionDir)\bin\</OutputPath>
+    <OutputPath>..\..\..\..\trunk\sources\bin\</OutputPath>
     <DefineConstants>TRACE</DefineConstants>
     <DocumentationFile>
@@ -83,5 +83,5 @@
   <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Debug|x64' ">
     <DebugSymbols>true</DebugSymbols>
-    <OutputPath>$(SolutionDir)\bin\</OutputPath>
+    <OutputPath>..\..\..\..\trunk\sources\bin\</OutputPath>
     <DefineConstants>DEBUG;TRACE</DefineConstants>
     <DebugType>full</DebugType>
@@ -91,5 +91,5 @@
   </PropertyGroup>
   <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|x64' ">
-    <OutputPath>$(SolutionDir)\bin\</OutputPath>
+    <OutputPath>..\..\..\..\trunk\sources\bin\</OutputPath>
     <DefineConstants>TRACE</DefineConstants>
     <DocumentationFile>
@@ -102,4 +102,19 @@
   </PropertyGroup>
   <ItemGroup>
+    <Reference Include="HeuristicLab.Collections-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <Private>False</Private>
+    </Reference>
+    <Reference Include="HeuristicLab.Common-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <Private>False</Private>
+    </Reference>
+    <Reference Include="HeuristicLab.Common.Resources-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <Private>False</Private>
+    </Reference>
+    <Reference Include="HeuristicLab.Persistence-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <Private>False</Private>
+    </Reference>
+    <Reference Include="HeuristicLab.PluginInfrastructure-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <Private>False</Private>
+    </Reference>
     <Reference Include="System" />
     <Reference Include="System.Core">
@@ -205,31 +220,4 @@
   </ItemGroup>
   <ItemGroup>
-    <ProjectReference Include="..\..\HeuristicLab.Collections\3.3\HeuristicLab.Collections-3.3.csproj">
-      <Project>{958B43BC-CC5C-4FA2-8628-2B3B01D890B6}</Project>
-      <Name>HeuristicLab.Collections-3.3</Name>
-      <Private>False</Private>
-    </ProjectReference>
-    <ProjectReference Include="..\..\HeuristicLab.Common.Resources\3.3\HeuristicLab.Common.Resources-3.3.csproj">
-      <Project>{0E27A536-1C4A-4624-A65E-DC4F4F23E3E1}</Project>
-      <Name>HeuristicLab.Common.Resources-3.3</Name>
-      <Private>False</Private>
-    </ProjectReference>
-    <ProjectReference Include="..\..\HeuristicLab.Common\3.3\HeuristicLab.Common-3.3.csproj">
-      <Project>{A9AD58B9-3EF9-4CC1-97E5-8D909039FF5C}</Project>
-      <Name>HeuristicLab.Common-3.3</Name>
-      <Private>False</Private>
-    </ProjectReference>
-    <ProjectReference Include="..\..\HeuristicLab.Persistence\3.3\HeuristicLab.Persistence-3.3.csproj">
-      <Project>{102BC7D3-0EF9-439C-8F6D-96FF0FDB8E1B}</Project>
-      <Name>HeuristicLab.Persistence-3.3</Name>
-      <Private>False</Private>
-    </ProjectReference>
-    <ProjectReference Include="..\..\HeuristicLab.PluginInfrastructure\3.3\HeuristicLab.PluginInfrastructure-3.3.csproj">
-      <Project>{94186A6A-5176-4402-AE83-886557B53CCA}</Project>
-      <Name>HeuristicLab.PluginInfrastructure-3.3</Name>
-      <Private>False</Private>
-    </ProjectReference>
-  </ItemGroup>
-  <ItemGroup>
     <BootstrapperPackage Include="Microsoft.Net.Client.3.5">
       <Visible>False</Visible>
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.CombinedIntegerVectorEncoding/3.3/CombinedIntegerVector.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.CombinedIntegerVectorEncoding/3.3/CombinedIntegerVector.cs	(revision 9193)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.CombinedIntegerVectorEncoding/3.3/CombinedIntegerVector.cs	(revision 9194)
@@ -21,4 +21,5 @@
 
 using System;
+using System.Collections.Generic;
 using System.Linq;
 using System.Text;
@@ -33,5 +34,5 @@
   [StorableClass]
   [Item("CombinedIntegerVector", "Represents a combined vector of integer values.")]
-  public class CombinedIntegerVector : IntegerVector, IClassifier {
+  public class CombinedIntegerVector : IntegerVector, IClassifier, ICondition, IAction, IInput {
 
     [Storable]
@@ -121,5 +122,5 @@
     }
 
-    public IClassifier Condition {
+    public ICondition Condition {
       get {
         int[] condition = new int[Length - actionLength];
@@ -129,5 +130,5 @@
     }
 
-    public IClassifier Action {
+    public IAction Action {
       get {
         int[] action = new int[actionLength];
@@ -152,8 +153,8 @@
     }
 
-    public bool MatchCondition(IClassifier target) {
+    public bool MatchInput(IInput target) {
       var targetVector = target as CombinedIntegerVector;
       if (targetVector == null) return false;
-      if (targetVector.Length != this.Length) return false;
+      if (targetVector.Length - targetVector.actionLength != this.Length - this.actionLength) return false;
 
       int curbounds;
@@ -171,6 +172,10 @@
     }
 
+    public bool MatchAction(IClassifier target) {
+      return MatchAction(target.Action);
+    }
+
     // no "don't care" symbols have to be considered
-    public bool MatchAction(IClassifier target) {
+    public bool MatchAction(IAction target) {
       var targetVector = target as CombinedIntegerVector;
       if (targetVector == null) return false;
@@ -188,4 +193,8 @@
 
     public bool IsMoreGeneral(IClassifier target) {
+      return IsMoreGeneral(target as ICondition);
+    }
+
+    public bool IsMoreGeneral(ICondition target) {
       var targetVector = target as CombinedIntegerVector;
       int curbounds;
@@ -201,4 +210,16 @@
       return true;
     }
+
+    #region ICondition Members
+    public bool Match(IInput target) {
+      return MatchInput(target);
+    }
+    #endregion
+
+    #region IAction Members
+    public bool Match(IAction target) {
+      return MatchAction(target);
+    }
+    #endregion
 
     private int NumberOfGeneralSymbols() {
@@ -233,14 +254,6 @@
     }
 
-    public override bool Equals(object obj) {
-      var cast = obj as CombinedIntegerVector;
-      if (cast != null) {
-        return this.Equals(cast);
-      }
-      return false;
-    }
-
-    public bool Equals(IClassifier other) {
-      var cast = other as CombinedIntegerVector;
+    public bool Identical(IClassifier target) {
+      var cast = target as CombinedIntegerVector;
       if (cast == null) { return false; }
       for (int i = 0; i < array.Length; i++) {
@@ -252,10 +265,53 @@
     }
 
+    public override bool Equals(object obj) {
+      return base.Equals(obj);
+    }
+
     public override int GetHashCode() {
-      int result = actionLength;
-      for (int i = 0; i < array.Length; i++) {
-        result ^= array[i];
-      }
-      return result.GetHashCode();
+      return base.GetHashCode();
+    }
+
+    [StorableClass]
+    [Item("CombinedIntegerVectorComparer", "")]
+    public class CombinedIntegerVectorComparer : Item, IEqualityComparer<CombinedIntegerVector>, IClassifierComparer {
+
+      [StorableConstructor]
+      protected CombinedIntegerVectorComparer(bool deserializing) : base(deserializing) { }
+      protected CombinedIntegerVectorComparer(CombinedIntegerVectorComparer original, Cloner cloner)
+        : base(original, cloner) {
+      }
+      public override IDeepCloneable Clone(Cloner cloner) {
+        return new CombinedIntegerVectorComparer(this, cloner);
+      }
+      public CombinedIntegerVectorComparer() : base() { }
+
+      public bool Equals(CombinedIntegerVector x, CombinedIntegerVector y) {
+        for (int i = 0; i < x.array.Length; i++) {
+          if (!x.array[i].Equals(y.array[i])) {
+            return false;
+          }
+        }
+        return true;
+      }
+
+      public int GetHashCode(CombinedIntegerVector obj) {
+        int result = obj.actionLength;
+        for (int i = 0; i < obj.array.Length; i++) {
+          result ^= obj.array[i];
+        }
+        return result.GetHashCode();
+      }
+
+      public bool Equals(IAction x, IAction y) {
+        var xCast = x as CombinedIntegerVector;
+        var yCast = y as CombinedIntegerVector;
+        return x != null && y != null && Equals(xCast, yCast);
+      }
+
+      public int GetHashCode(IAction obj) {
+        var objCast = obj as CombinedIntegerVector;
+        return objCast != null ? GetHashCode(objCast) : obj.GetHashCode();
+      }
     }
   }
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.CombinedIntegerVectorEncoding/3.3/CombinedIntegerVectorManipulator.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.CombinedIntegerVectorEncoding/3.3/CombinedIntegerVectorManipulator.cs	(revision 9193)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.CombinedIntegerVectorEncoding/3.3/CombinedIntegerVectorManipulator.cs	(revision 9194)
@@ -39,5 +39,5 @@
       get { return (ILookupParameter<CombinedIntegerVector>)Parameters["Child"]; }
     }
-    public ILookupParameter<CombinedIntegerVector> FetchedClassifierParameter {
+    public ILookupParameter<CombinedIntegerVector> FetchedConditionParameter {
       get { return (ILookupParameter<CombinedIntegerVector>)Parameters["Parent"]; }
     }
@@ -57,5 +57,5 @@
 
     public sealed override IOperation Apply() {
-      ChildParameter.ActualValue = Manipulate(RandomParameter.ActualValue, FetchedClassifierParameter.ActualValue, ChildParameter.ActualValue);
+      ChildParameter.ActualValue = Manipulate(RandomParameter.ActualValue, FetchedConditionParameter.ActualValue, ChildParameter.ActualValue);
       return base.Apply();
     }
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.CombinedIntegerVectorEncoding/3.3/Covering/CombinedIntegerVectorCoveringCreator.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.CombinedIntegerVectorEncoding/3.3/Covering/CombinedIntegerVectorCoveringCreator.cs	(revision 9193)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.CombinedIntegerVectorEncoding/3.3/Covering/CombinedIntegerVectorCoveringCreator.cs	(revision 9194)
@@ -34,9 +34,9 @@
 
     #region Parameter Properties
-    public ILookupParameter<IClassifier> CoverClassifierParameter {
-      get { return (ILookupParameter<IClassifier>)Parameters["CoverClassifier"]; }
+    public ILookupParameter<IInput> CoverInputParameter {
+      get { return (ILookupParameter<IInput>)Parameters["CoverInput"]; }
     }
-    public ILookupParameter<IClassifier> ActionParameter {
-      get { return (ILookupParameter<IClassifier>)Parameters["Action"]; }
+    public ILookupParameter<IAction> ActionParameter {
+      get { return (ILookupParameter<IAction>)Parameters["Action"]; }
     }
     public IValueLookupParameter<IClassifier> CreatedClassifierParameter {
@@ -62,6 +62,6 @@
     public CombinedIntegerVectorCoveringCreator()
       : base() {
-      Parameters.Add(new LookupParameter<IClassifier>("CoverClassifier"));
-      Parameters.Add(new LookupParameter<IClassifier>("Action"));
+      Parameters.Add(new LookupParameter<IInput>("CoverInput"));
+      Parameters.Add(new LookupParameter<IAction>("Action"));
       Parameters.Add(new ValueLookupParameter<IClassifier>("CreatedClassifier"));
       Parameters.Add(new LookupParameter<PercentValue>("ChangeSymbolProbability"));
@@ -70,8 +70,8 @@
 
     public override IOperation Apply() {
-      CombinedIntegerVector newCondition = (CombinedIntegerVector)CoverClassifierParameter.ActualValue.Condition.Clone();
+      CombinedIntegerVector newCondition = (CombinedIntegerVector)CoverInputParameter.ActualValue.Clone();
 
-      CombinedIntegerVector condition = (CombinedIntegerVector)CoverClassifierParameter.ActualValue.Condition;
-      CombinedIntegerVector action = (CombinedIntegerVector)ActionParameter.ActualValue.Action;
+      CombinedIntegerVector condition = (CombinedIntegerVector)CoverInputParameter.ActualValue;
+      CombinedIntegerVector action = (CombinedIntegerVector)ActionParameter.ActualValue;
 
       newCondition = UniformSomePositionManipulator.ManipulateCondition(RandomParameter.ActualValue, condition, newCondition, ChangeSymbolProbabilityParameter.ActualValue.Value);
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.CombinedIntegerVectorEncoding/3.3/HeuristicLab.Encodings.CombinedIntegerVectorEncoding-3.3.csproj
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.CombinedIntegerVectorEncoding/3.3/HeuristicLab.Encodings.CombinedIntegerVectorEncoding-3.3.csproj	(revision 9193)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.CombinedIntegerVectorEncoding/3.3/HeuristicLab.Encodings.CombinedIntegerVectorEncoding-3.3.csproj	(revision 9194)
@@ -89,7 +89,4 @@
       <Private>False</Private>
     </Reference>
-    <Reference Include="HeuristicLab.Core-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
-      <Private>False</Private>
-    </Reference>
     <Reference Include="HeuristicLab.Data-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
       <Private>False</Private>
@@ -149,4 +146,8 @@
   </ItemGroup>
   <ItemGroup>
+    <ProjectReference Include="..\..\HeuristicLab.Core\3.3\HeuristicLab.Core-3.3.csproj">
+      <Project>{C36BD924-A541-4A00-AFA8-41701378DDC5}</Project>
+      <Name>HeuristicLab.Core-3.3</Name>
+    </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.Encodings.ConditionActionEncoding\3.3\HeuristicLab.Encodings.ConditionActionEncoding-3.3.csproj">
       <Project>{422FB262-0845-4969-8D16-12F057AA90B1}</Project>
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.CombinedIntegerVectorEncoding/3.3/Interfaces/ICombinedIntegerVectorManipulator.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.CombinedIntegerVectorEncoding/3.3/Interfaces/ICombinedIntegerVectorManipulator.cs	(revision 9193)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.CombinedIntegerVectorEncoding/3.3/Interfaces/ICombinedIntegerVectorManipulator.cs	(revision 9194)
@@ -29,5 +29,5 @@
   public interface ICombinedIntegerVectorManipulator : IManipulator, ICombinedIntegerVectorOperator {
     ILookupParameter<CombinedIntegerVector> ChildParameter { get; }
-    ILookupParameter<CombinedIntegerVector> FetchedClassifierParameter { get; }
+    ILookupParameter<CombinedIntegerVector> FetchedConditionParameter { get; }
   }
 }
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/ActionSelection/ActionSelector.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/ActionSelection/ActionSelector.cs	(revision 9193)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/ActionSelection/ActionSelector.cs	(revision 9194)
@@ -37,9 +37,9 @@
       get { return (ILookupParameter<IRandom>)Parameters["Random"]; }
     }
-    public IValueLookupParameter<IClassifier> SelectedActionParameter {
-      get { return (IValueLookupParameter<IClassifier>)Parameters["SelectedAction"]; }
+    public IValueLookupParameter<IAction> SelectedActionParameter {
+      get { return (IValueLookupParameter<IAction>)Parameters["SelectedAction"]; }
     }
-    public ILookupParameter<IItemDictionary<IClassifier, DoubleValue>> PredictionArrayParameter {
-      get { return (ILookupParameter<IItemDictionary<IClassifier, DoubleValue>>)Parameters["PredictionArray"]; }
+    public ILookupParameter<IItemDictionary<IAction, DoubleValue>> PredictionArrayParameter {
+      get { return (ILookupParameter<IItemDictionary<IAction, DoubleValue>>)Parameters["PredictionArray"]; }
     }
     public ILookupParameter<PercentValue> ExplorationProbabilityParameter {
@@ -55,6 +55,6 @@
       : base() {
       Parameters.Add(new LookupParameter<IRandom>("Random"));
-      Parameters.Add(new ValueLookupParameter<IClassifier>("SelectedAction", "Action, which has been selected."));
-      Parameters.Add(new LookupParameter<IItemDictionary<IClassifier, DoubleValue>>("PredictionArray"));
+      Parameters.Add(new ValueLookupParameter<IAction>("SelectedAction", "Action, which has been selected."));
+      Parameters.Add(new LookupParameter<IItemDictionary<IAction, DoubleValue>>("PredictionArray"));
       Parameters.Add(new LookupParameter<PercentValue>("ExplorationProbability"));
     }
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/ActionSelection/MaxValueActionSelector.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/ActionSelection/MaxValueActionSelector.cs	(revision 9193)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/ActionSelection/MaxValueActionSelector.cs	(revision 9194)
@@ -36,4 +36,7 @@
       get { return (ILookupParameter<ItemArray<DoubleValue>>)Parameters["ValueParameter"]; }
     }
+    public ILookupParameter<IClassifierComparer> ClassifierComparerParameter {
+      get { return (ILookupParameter<IClassifierComparer>)Parameters["ClassifierComparer"]; }
+    }
 
     [StorableConstructor]
@@ -43,4 +46,5 @@
       : base() {
       Parameters.Add(new ScopeTreeLookupParameter<DoubleValue>("ValueParameter", "DoubleValue which will be summed up."));
+      Parameters.Add(new LookupParameter<IClassifierComparer>("ClassifierComparer"));
     }
     public override IDeepCloneable Clone(Cloner cloner) {
@@ -48,6 +52,6 @@
     }
 
-    protected override IClassifier SelectAction(List<IScope> scopes) {
-      Dictionary<IClassifier, double> actionSet = new Dictionary<IClassifier, double>();
+    protected override IAction SelectAction(List<IScope> scopes) {
+      Dictionary<IAction, double> actionSet = new Dictionary<IAction, double>(ClassifierComparerParameter.ActualValue);
       for (int i = 0; i < MatchParameter.ActualValue.Length; i++) {
         var action = MatchParameter.ActualValue[i].Action;
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/ActionSelection/OldActionSelector.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/ActionSelection/OldActionSelector.cs	(revision 9193)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/ActionSelection/OldActionSelector.cs	(revision 9194)
@@ -38,6 +38,6 @@
       get { return (ILookupParameter<ItemArray<IClassifier>>)Parameters["MatchParameter"]; }
     }
-    public IValueLookupParameter<IClassifier> SelectedActionParameter {
-      get { return (IValueLookupParameter<IClassifier>)Parameters["SelectedAction"]; }
+    public IValueLookupParameter<IAction> SelectedActionParameter {
+      get { return (IValueLookupParameter<IAction>)Parameters["SelectedAction"]; }
     }
 
@@ -54,5 +54,5 @@
       Parameters.Add(new ScopeParameter("CurrentScope", "The current scope from which sub-scopes should be selected."));
       Parameters.Add(new ScopeTreeLookupParameter<IClassifier>("MatchParameter", "The matching encoding contained in each sub-scope which is used for selection."));
-      Parameters.Add(new ValueLookupParameter<IClassifier>("SelectedAction", "Action, which has been selected."));
+      Parameters.Add(new ValueLookupParameter<IAction>("SelectedAction", "Action, which has been selected."));
     }
 
@@ -63,5 +63,5 @@
     }
 
-    protected abstract IClassifier SelectAction(List<IScope> scopes);
+    protected abstract IAction SelectAction(List<IScope> scopes);
   }
 }
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/ActionSelection/RandomActionSelector.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/ActionSelection/RandomActionSelector.cs	(revision 9193)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/ActionSelection/RandomActionSelector.cs	(revision 9194)
@@ -45,5 +45,5 @@
     }
 
-    protected override IClassifier SelectAction(List<IScope> scopes) {
+    protected override IAction SelectAction(List<IScope> scopes) {
       IRandom random = RandomParameter.ActualValue;
       int index = random.Next(MatchParameter.ActualValue.Length);
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Analyzer/XCSSolutionAnalyzer.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Analyzer/XCSSolutionAnalyzer.cs	(revision 9193)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Analyzer/XCSSolutionAnalyzer.cs	(revision 9194)
@@ -66,4 +66,7 @@
       get { return (ValueLookupParameter<ResultCollection>)Parameters["Results"]; }
     }
+    public ILookupParameter<IClassifierComparer> ClassifierComparerParameter {
+      get { return (ILookupParameter<IClassifierComparer>)Parameters["ClassifierComparer"]; }
+    }
 
     public ResultCollection Results { get { return ResultsParameter.ActualValue; } }
@@ -84,4 +87,5 @@
       Parameters.Add(new LookupParameter<IConditionActionProblemData>("ProblemData", ""));
       Parameters.Add(new ValueLookupParameter<ResultCollection>("Results", "The result collection where the solution should be stored."));
+      Parameters.Add(new LookupParameter<IClassifierComparer>("ClassifierComparer"));
     }
 
@@ -105,5 +109,5 @@
 
       XCSModel xcsModel = new XCSModel(xcsClassifiers);
-
+      xcsModel.ClassifierComparer = ClassifierComparerParameter.ActualValue;
       UseCurrentXCSSolution(xcsModel.CreateConditionActionSolution(problemData));
       return base.Apply();
